<template>
    <div class="log-in-page">
        <div class="columns">
            <div class="columns is-4 is-offset-4">
                <h1 class="title"> Log in </h1>

                <form @submit.prevent="submitForm">
                    <div class="field">
                        <label>Username</label>
                        <div class="control">
                            <input type="text" class="input" v-model="username">
                        </div>

                    </div>

                    <div class="field">
                        <label>Password</label>
                        <div class="control">
                            <input type="password" class="input" v-model="password">
                        </div>
                    </div>

                    <div class="notification is-danger" v-if="errors.length">
                        <p v-for="error in errors" v-bind:key="error"> {{ error }} </p>
                    </div>
                    <br>
                    <div class="field">
                        <div class="control">
                            <button class="button is-dark">Log In</button>
                        </div>
                    </div>
                    <br>
                    <hr>
                    <br>

                    or <router-link to="/sign-up">click here</router-link> to sign in!

                </form>

            </div>

        </div>
    </div>
</template>

<script>
//import axios from "axios"

import axios from 'axios'

/* eslint-disable */
export default {
    name: 'LogIn',
    data() {
        return {
            username: '',
            password: '',
            errors:[]
        }
    },
    mounted() {
      document.title = 'Log In'
    },
    methods: {
        async  submitForm() {
            axios.defaults.headers.common['Authorization'] = ''
            localStorage.removeItem['access']

            const formData = {
                username: this.username,
                password: this.password,
            }

            await axios
                .post('/api/v1/jwt/create/', formData)
                .then(response => {

                    const access = response.data.access

                    this.$store.commit('setAccess', access)

                    axios.defaults.headers.common['Authorization'] = ' JWT ' + access

                    localStorage.setItem['access', access]

                    this.$router.push('/')
                })
                .catch(error => {
                    if (error.response) {
                        for (const property in error.response.data) {
                            this.errors.push(`${property}: ${error.response.data[property]}`)
                        }
                    } else {
                        this.errors.push('Something went wrong. Please try again')
                        console.log(JSON.stringify(error))
                    }
                })
        }
    }
}
/* eslint-enable */
</script>
